#ifndef __gostcrypt_included__
#define __gostcrypt_included__

#include <crypt.h>

#define GOST_CRYPT_SALT_PREFIX        GOST12_512_CRYPT_SALT_PREFIX

#define GOST94_CRYPT_SALT_PREFIX      "$gost94hash$"
#define GOST12_256_CRYPT_SALT_PREFIX  "$gost12256hash$"
#define GOST12_512_CRYPT_SALT_PREFIX  "$gost12512hash$"

#define GOST_CRYPT_COMMON_SALT_PREFIX "$gost"

/* Prototypes for local functions */
extern char *gost_crypt_r(const char *key, const char *salt,char *buffer, int buflen);
extern char *gost_crypt(const char *key, const char *salt);

extern char *gost94_crypt_r(const char *key, const char *salt,char *buffer, int buflen);
extern char *gost94_crypt(const char *key, const char *salt);

extern char *gost12_256_crypt_r(const char *key, const char *salt,char *buffer, int buflen);
extern char *gost12_512_crypt_r(const char *key, const char *salt,char *buffer, int buflen);

extern char *gost12_256_crypt(const char *key, const char *salt);
extern char *gost12_512_crypt(const char *key, const char *salt);

extern char *crypt_w_gost_r(const char *key, const char *salt, struct crypt_data *cdata);
extern char *crypt_w_gost(const char *key, const char *salt);

#endif
