#ifndef GOSTHASH_H
#define GOSTHASH_H

#ifdef __cplusplus
extern "C" {
#endif


#include "gost89.h"
#include <stdlib.h>

typedef struct gost_hash_ctx {
		long long len;
		gost_ctx cipher_ctx;
		int left;
		byte H[32];
		byte S[32];
		byte remainder[32];
} gost_hash_ctx;		


void init_gost_hash_ctx(gost_hash_ctx *ctx, const gost_subst_block *subst_block);
//void done_gost_hash_ctx(gost_hash_ctx *ctx);

void start_hash(gost_hash_ctx *ctx);
void hash_block(gost_hash_ctx *ctx, const byte *block, size_t length);

void finish_hash(gost_hash_ctx *ctx, byte *hashval);

#ifdef __cplusplus
}
#endif

#endif
